import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Random;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;


public class GUI extends JFrame{
	
	int trIgr=1;//trenutni broj igraca
	Color trBoja=Color.WHITE,mark;//boja trenutnog igraca,markiranje polja
	int clicked=0;//trenutni broj klika
	int kraj=0;//pokazuje da je kraj igre
	String winner="BELI";//boja pobednika
	int brC=0,brB=0;//broj poteza crnih i broj poteza belih

	JLabel labPot = new JLabel();
	JLabel labTrP = new JLabel();

	MyButton potez = new MyButton();

	MyButton polja[][] = new MyButton[8][8];
	
	//dugmici za polja sa sve akcijama
	class MyButton extends JButton implements ActionListener{
		int i,j;
		String figura="";
		Color boja;
		@Override
		public void actionPerformed(ActionEvent arg0) {
			MyButton x = (MyButton)arg0.getSource();
			clicked++;
			if (clicked==1){
				potez=polja[x.i][x.j];
				mark=potez.getBackground();
				potez.setBackground(Color.BLUE);
			} else {
				if ((trIgr%2)==1) {
					trBoja = Color.WHITE;
					winner="BELI";
				} else {
					trBoja = Color.BLACK;
					winner="CRNI";
				}
				if (potez.figura=="") clicked=0; else
				if (potez.boja!=trBoja) clicked=0; else
				if ((potez.i==x.i)&&(potez.j==x.j)) clicked=0; else
				if ((potez.boja==x.boja)&&(potez.boja==x.boja)) clicked=0; else
				if (potez.figura=="kralj"){
					if (((potez.i-x.i)>=-1)&&((potez.i-x.i)<=1)&&((potez.j-x.j)>=-1)&&((potez.j-x.j)<=1)) {
						if ((x.figura=="kralj")&&(x.boja!=trBoja)) kraj=1;
						potez.figura="";
						potez.setIcon(null);
						potez.boja=Color.RED;
						x.figura="kralj";
						if (winner=="BELI") x.setIcon(new ImageIcon("K[Bela].png"));
						else x.setIcon(new ImageIcon("K[Crna].png"));
						x.boja=trBoja;
						if ((trIgr%2)==1) {
							trBoja = Color.WHITE;
							winner="BELI";
						} else {
							trBoja = Color.BLACK;
							winner="CRNI";
						}
						clicked=0;
						if ((trIgr%2)==0) {
							brB++;
							labPot.setText("Broj poteza "+brB);
							labTrP.setText("BELI je na potezu");
						} else {
							brC++;
							labPot.setText("Broj poteza "+brC);
							labTrP.setText("CRNI je na potezu");
						}
						trIgr++;
						if (kraj==1) {
							if (JOptionPane.showConfirmDialog(null, winner+" je pobedio\nNova igra?","Borba skakaca",JOptionPane.YES_NO_OPTION,JOptionPane.QUESTION_MESSAGE)!=JOptionPane.OK_OPTION) System.exit(0);
							else newGame();
						}
					}
				}else
				if (potez.figura=="skakac"){
					if (((x.i-potez.i==1)&&(x.j-potez.j==2))||((x.i-potez.i==1)&&(x.j-potez.j==-2))||((x.i-potez.i==-1)&&(x.j-potez.j==2))||
						((x.i-potez.i==-1)&&(x.j-potez.j==-2))||((x.i-potez.i==2)&&(x.j-potez.j==1))||((x.i-potez.i==2)&&(x.j-potez.j==-1))||
						((x.i-potez.i==-2)&&(x.j-potez.j==1))||((x.i-potez.i==-2)&&(x.j-potez.j==-1))) {
						if ((x.figura=="kralj")&&(x.boja!=trBoja)) kraj=1;
						potez.figura="";
						potez.setIcon(null);
						potez.boja=Color.RED;
						x.figura="skakac";
						if (winner=="BELI") x.setIcon(new ImageIcon("S[Bela].png"));
						else x.setIcon(new ImageIcon("S[Crna].png"));
						x.boja=trBoja;
						if ((trIgr%2)==0) {
							brB++;
							labPot.setText("Broj poteza "+brB);
							labTrP.setText("BELI je na potezu");
						} else {
							brC++;
							labPot.setText("Broj poteza "+brC);
							labTrP.setText("CRNI je na potezu");
						}
						if (kraj==1) {
							if (JOptionPane.showConfirmDialog(null, winner+" je pobedio\nNova igra?","Borba skakaca",JOptionPane.YES_NO_OPTION,JOptionPane.QUESTION_MESSAGE)!=JOptionPane.OK_OPTION) System.exit(0);
							else newGame();
						}
						trIgr++;
						clicked=0;
					}
				}
				clicked=0;
				potez.setBackground(mark);
			}
		}
		
	}
	
	//konsturktor
	public GUI(){
		makeGUI();
		newGame();
	}
	
	//pravi gui
	public void makeGUI(){
		setVisible(true);
		setBounds(100,100,500,500);
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setTitle("Borba skakaca");
		setLayout(new BorderLayout());
		makeTop();
		makeCenter();
		makeBottom();
	}
	
	//gornji panel sa labelama
	public void makeTop(){
		JPanel top = new JPanel();
		top.setLayout(new BorderLayout());
		labPot.setText("Broj poteza 0");
		labTrP.setText("BELI je na potezu");
		add(top,BorderLayout.NORTH);
		top.add(labPot,BorderLayout.WEST);
		top.add(labTrP,BorderLayout.EAST);
	}
	
	//sahovska tabla
	public void makeCenter(){
		JPanel center = new JPanel();
		center.setLayout(new GridLayout(8,8));
		add(center,BorderLayout.CENTER);
		for (int i=0;i<8;i++)
			for (int j=0;j<8;j++){
				polja[i][j] = new MyButton();
				center.add(polja[i][j]);
				//polja[i][j].setEnabled(false);
				polja[i][j].i=i;
				polja[i][j].j=j;
				polja[i][j].boja=Color.RED;
				polja[i][j].addActionListener(polja[i][j]);
				if ((i+j)%2==0) polja[i][j].setBackground(Color.WHITE); else polja[i][j].setBackground(Color.LIGHT_GRAY);
			}
	}

	//donji deo igrice sa dugmetom za novu igru
	public void makeBottom(){
		JPanel bottom = new JPanel();
		JButton nova = new JButton("Nova");
		add(bottom,BorderLayout.SOUTH);
		bottom.add(nova);
		nova.addActionListener(new ActionListener(){
	
			@Override
			public void actionPerformed(ActionEvent arg0) {
				newGame();
			}
		});
	}
	
	//nova igra
	public void newGame(){
		for (int i=0;i<8;i++)
			for (int j=0;j<8;j++){
				polja[i][j].boja=Color.RED;
				polja[i][j].setIcon(null);
				polja[i][j].figura="";
			}
		generate();
		trIgr=1;
		trBoja=Color.WHITE;
		clicked=0;
		kraj=0;
		String winner="BELI";
		brC=0;
		brB=0;
		labPot.setText("Broj poteza "+brB);
		labTrP.setText("BELI je na potezu");
	}
	
	//generise pozicije figura na pocetku
	public void generate(){
		Random r = new Random();
		int k;
		for (int i=0;i<3;i++){
			do{
				k=r.nextInt(8);
			} while (polja[0][k].figura!="");
			polja[0][k].figura="skakac";
			polja[0][k].setIcon(new ImageIcon("S[Bela].png"));
			polja[0][k].boja=Color.WHITE;
		}
		do{
			k=r.nextInt(8);
		} while (polja[0][k].figura!="");
		polja[0][k].figura="kralj";
		polja[0][k].setIcon(new ImageIcon("K[Bela].png"));
		polja[0][k].boja=Color.WHITE;
		//
		for (int i=0;i<3;i++){
			do{
				k=r.nextInt(8);
			} while (polja[7][k].figura!="");
			polja[7][k].figura="skakac";
			polja[7][k].setIcon(new ImageIcon("S[Crna].png"));
			polja[7][k].boja=Color.BLACK;
		}
		do{
			k=r.nextInt(8);
		} while (polja[7][k].figura!="");
		polja[7][k].figura="kralj";
		polja[7][k].setIcon(new ImageIcon("K[Crna].png"));
		polja[7][k].boja=Color.BLACK;
	}
}
