import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Container;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.border.LineBorder;


public class Gui extends JFrame{

	JLabel labela=new JLabel();	
	myButton polje[][]=new myButton[8][8];
	int status[][]=new int[8][8];
	Color boje[]={Color.WHITE,Color.GRAY};
	int klik=0;
	Engine engine=new Engine();
	
	public Gui(String s){
		super(s);
		
		setBounds(100,100,500,600);
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setResizable(false);
		
		Container cp = getContentPane();
		cp.setLayout(new GridLayout(8,8));
		
		int br=0;
		
		for(int i=0;i<8;i++){
			for(int j=0;j<8;j++){
				polje[i][j]=new myButton(i,j);
				add(polje[i][j]);
				
				br=(++br)%2;
			}
			if(br==1)br=0;
			else br=1;
		}
		
		setVisible(true);
		status=engine.initialize();
		refreshTable();
	}

	

	private void refreshTable() {
		for(int i=0;i<8;i++)
			for(int j=0;j<8;j++)
			{
				if(status[i][j]==1)polje[i][j].setIcon(new ImageIcon("K[CRNA].png"));
				else polje[i][j].setIcon(null);
			}
	}



	private void namestiSever() {
		
		add(labela,BorderLayout.NORTH);
		labela.setText("Broj poteza:0");
	}
	
private void namestiCentar() {
				
	
	}


}
