import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;


public class Prozor extends JFrame{

	Container cp;
	
	JLabel ispis = new JLabel("Poteza: ");
	
	DugmeBelo beli[] = new DugmeBelo[32];
	DugmeSivo sivi[] = new DugmeSivo[32];
	
	public Prozor(){
		
		setVisible(true);
		setTitle("N Pesaka");
		setDefaultCloseOperation(EXIT_ON_CLOSE);
		setBounds(200, 200, 400, 400);
		
		setLayout(new BorderLayout());
		
		cp=getContentPane();
		
		ispis.setBorder(BorderFactory.createEmptyBorder(0, 5, 100, 0));
		cp.add(ispis,BorderLayout.NORTH);
		tabla();
	}
	
	public void tabla(){
		JPanel glavni = new JPanel();
		JPanel x = new JPanel();
		JPanel y = new JPanel();
		
		GridBagConstraints c = new GridBagConstraints();
		
		glavni.setLayout(new GridBagLayout());
		x.setLayout(new GridLayout(8,8));
		
		for(int i=0; i<32; i++){
			beli[i] = new DugmeBelo();
			beli[i].setPreferredSize(new Dimension(30,30));
			x.add(beli[i]);
			c.gridy=0;
			c.weighty=20;
			c.ipady=10;
			c.ipadx=20;
			glavni.add(x);
		}
		
		cp.add(glavni,BorderLayout.CENTER);
		
		for(int i=1; i<32; i+=2){
			sivi[i] = new DugmeSivo();
			sivi[i].setPreferredSize(new Dimension(30,30));
			x.add(sivi[i]);
			c.gridy=0;
			c.weighty=20;
			c.ipady=10;
			c.ipadx=20;
			glavni.add(x);
		}
		cp.add(glavni,BorderLayout.CENTER);
		
	}
	
	class DugmeBelo extends JButton{
		
		public DugmeBelo(){
			setPreferredSize(new Dimension(41, 41));
			setBackground(Color.WHITE);
		}
	}
	
	class DugmeSivo extends JButton{
		
		public DugmeSivo(){
			setPreferredSize(new Dimension(41, 41));
			setBackground(Color.GRAY);
		}
	}
	
}
