
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;


public class GUI extends JFrame {

	JLabel l1;
	MyButton dugme[] = new MyButton[64];
	NPawnEngine e = new NPawnEngine();
	
	public GUI(){
		
		setLayout(new BorderLayout(5, 5));
		setTitle("N Pesaka");
		
		l1 = new JLabel("Potez: 0");
		add(l1,BorderLayout.NORTH);
		
		JPanel centar = new JPanel(new GridLayout(8, 8, 2, 2));
		int brojac=0;
		for(int i=0;i<64;i++){
			dugme[i] = new MyButton();
			dugme[i].addActionListener(new ActionListener() {
				
				@Override
				public void actionPerformed(ActionEvent arg0) {
					int op=JOptionPane.showConfirmDialog(null, "Zavrsena igra u "+e.getMoves()+" poteza.\n Nova igra?","N Pesaka",JOptionPane.YES_NO_OPTION,JOptionPane.QUESTION_MESSAGE);

						
					
				}
			});
			brojac++;
			centar.add(dugme[i]);
			if(brojac<=8 || brojac>16 && brojac<=24  || brojac>32 && brojac<=40 || brojac>48 && brojac<=56 || brojac>64 && brojac<=72){
				if((i+1)%2==0)
					dugme[i].setBackground(Color.WHITE);
				else
					dugme[i].setBackground(Color.GRAY);
			}
			else {
				if((i+1)%2==0)
					dugme[i].setBackground(Color.GRAY);
				else
					dugme[i].setBackground(Color.WHITE);
			}
		}
		add(centar);
		
		setBounds(40, 40, 500, 500);
		setVisible(true);
		
	}
}
