package igrica_laksi;

import javax.swing.*;
import javax.swing.border.LineBorder;

import java.awt.*;
import java.awt.event.*;

public class MojProzor extends JFrame {
	
	Container cp;
	Engine igrica;
	int brPoteza;
	MojeDugme dugmad[][];
	int pom1,pom2;
	public MojProzor(String ime){
		super(ime);
		setBounds(20,20,400,500);
		setDefaultCloseOperation(EXIT_ON_CLOSE);
		cp=getContentPane();
		igrica= new Engine(8, 8, 8);
		brPoteza=0;
		dugmad= new MojeDugme[8][8];
		for(int i=0; i<8; i++)
			for(int j=0; j<8; j++){
				pom1=i;
				pom2=j;
				dugmad[i][j]= new MojeDugme(" ");
				dugmad[i][j].addActionListener(new ActionListener() {
					
					@Override
					public void actionPerformed(ActionEvent arg0) {
						if(dugmad[pom1][pom2].vrd==1){
							dugmad[pom1][pom2].setText(" ");
							dugmad[pom1][pom2].vrd=0;
						}
						else{
							dugmad[pom1][pom2].vrd=1;
							dugmad[pom1][pom2].setText("X");
						}
						brPoteza++;
							
						
						
					}
				});
			}
		
		setBackground(Color.GRAY);
		kostur();
		setVisible(true);
	}
	
	public void dodajGore(){
		JPanel pane1= new JPanel(new FlowLayout(FlowLayout.LEFT));
		JLabel label1= new JLabel("Poteza: " + brPoteza);
		pane1.add(label1);
		pane1.setBackground(Color.DARK_GRAY);
		cp.add(pane1, BorderLayout.NORTH);
	    
	}
	public void dodajSredina(){
		int boja=0;
		JPanel pane2= new JPanel(new GridLayout(8,8));
		for(int i=0; i<8; i++){
			for(int j=0; j<8; j++) {
				if(boja%2==0) dugmad[i][j].setBackground(Color.WHITE);
				else dugmad[i][j].setBackground(Color.GRAY);
				boja++;
				dugmad[i][j].setI(i);
				dugmad[i][j].setJ(j);
				dugmad[i][j].vrd=0;
				dugmad[i][j].setBorder(new LineBorder(Color.lightGray, 3));
				pane2.add(dugmad[i][j]);
				

			}

		boja++;
		}
		cp.add(pane2,BorderLayout.CENTER);
		
	}
	public void kostur(){
		dodajGore();
		dodajSredina();
	}
	public void reset(){
		for(int i=0; i<8; i++)
			for(int j=0; j<8; j++) dugmad[i][j].setText(" ");
	}
	public void nova(){
		int vrd[];
		vrd= new int[2];
		brPoteza=0;
		reset();
		igrica.initialize();
		for(int i=0; i<8; i++){
			vrd=igrica.deployFigure();
			dugmad[vrd[0]][vrd[1]].vrd=1;
			dugmad[vrd[0]][vrd[1]].setText("X");
		}
		
		
		
	}

}
class MojeDugme extends JButton{
	/*gde se dugme nalazi*/
	int i; 
	int j;
	int vrd;
	public MojeDugme(String ime){
		super(ime);
	}
	public void setI(int i){
		this.i=i;
	}
	public void setJ(int j){
		this.j=j;
	}
	public int getI(){
		return i;
	}
	public int getJ(){
		return j;
	}
}
